#version 120
#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect texEntry;
uniform sampler2DRect texExit;
uniform sampler3D texVolume;
uniform float dz;

const float DELTA = 0.005;

//const float dz = 0.002;
const int maxrange = 347;

void main()
{
	vec4 front = texture2DRect(texEntry, gl_FragCoord.xy);
	if (front.w == 0)
		discard;

	vec4 back = texture2DRect(texExit, gl_FragCoord.xy);
	vec4 direction = back - front;
	vec4 stepSize = normalize(direction) * dz;
	int maxiter = int(floor(length(direction) / dz));

	vec4 pos = front;
	vec4 result = vec4(0, 0, 0, 0);
	
	for(int i = 0; i < maxiter; i++) {

		vec4 intensity = texture3D(texVolume, pos.xyz);
		if(intensity.x > result.x)
		  result = intensity;

		pos += stepSize;

		if (result.x >= 1.0)
			break;
		
		//if (pos.x < 0 || pos.x > 1 || pos.y < 0 || pos.y > 1 || pos.z < 0 || pos.z > 1)
		//	break;
	}

	gl_FragColor = result;
}
